diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/test/channel-access-manager-test.cc ns-3.36/src/wifi/test/channel-access-manager-test.cc
--- ns-3.35/src/wifi/test/channel-access-manager-test.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/test/channel-access-manager-test.cc	2022-04-30 18:23:58.218735200 -0700
@@ -64,8 +64,6 @@
   void NotifyChannelAccessed (Time txopDuration = Seconds (0)) override;
   /// \copydoc ns3::Txop::HasFramesToTransmit
   bool HasFramesToTransmit (void) override;
-  /// \copydoc ns3::Txop::NotifyChannelSwitching
-  void NotifyChannelSwitching (void) override;
   /// \copydoc ns3::Txop::NotifySleep
   void NotifySleep (void) override;
   /// \copydoc ns3::Txop::NotifyWakeUp
@@ -193,6 +191,11 @@
   {
     m_test->NotifyInternalCollision (DynamicCast<TxopTest<TxopType>> (txop));
   }
+  /// \copydoc ns3::FrameExchangeManager::NotifySwitchingStartNow
+  void NotifySwitchingStartNow (Time duration) override
+  {
+    m_test->NotifyChannelSwitching ();
+  }
 
 private:
   ChannelAccessManagerTest<TxopType> *m_test; //!< the test DCF/EDCA manager
@@ -228,9 +231,8 @@
   void GenerateBackoff (uint32_t i);
   /**
    * Notify channel switching function
-   * \param i the index of the Txop
    */
-  void NotifyChannelSwitching (uint32_t i);
+  void NotifyChannelSwitching (void);
 
 
 private:
@@ -430,13 +432,6 @@
 
 template <typename TxopType>
 void
-TxopTest<TxopType>::NotifyChannelSwitching (void)
-{
-  m_test->NotifyChannelSwitching (m_i);
-}
-
-template <typename TxopType>
-void
 TxopTest<TxopType>::NotifySleep (void)
 {
 }
@@ -509,16 +504,18 @@
 
 template <typename TxopType>
 void
-ChannelAccessManagerTest<TxopType>::NotifyChannelSwitching (uint32_t i)
+ChannelAccessManagerTest<TxopType>::NotifyChannelSwitching (void)
 {
-  Ptr<TxopTest<TxopType>> state = m_txop[i];
-  if (!state->m_expectedGrants.empty ())
+  for (auto& state : m_txop)
     {
-      std::pair<uint64_t, uint64_t> expected = state->m_expectedGrants.front ();
-      state->m_expectedGrants.pop_front ();
-      NS_TEST_EXPECT_MSG_EQ (Simulator::Now (), MicroSeconds (expected.second), "Expected grant is now");
+      if (!state->m_expectedGrants.empty ())
+        {
+          std::pair<uint64_t, uint64_t> expected = state->m_expectedGrants.front ();
+          state->m_expectedGrants.pop_front ();
+          NS_TEST_EXPECT_MSG_EQ (Simulator::Now (), MicroSeconds (expected.second), "Expected grant is now");
+        }
+      state->Txop::m_access = Txop::NOT_REQUESTED;
     }
-  state->Txop::m_access = Txop::NOT_REQUESTED;
 }
 
 template <typename TxopType>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/test/inter-bss-test-suite.cc ns-3.36/src/wifi/test/inter-bss-test-suite.cc
--- ns-3.35/src/wifi/test/inter-bss-test-suite.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/test/inter-bss-test-suite.cc	2022-04-30 18:23:58.218735200 -0700
@@ -281,25 +281,25 @@
   // AP2 sends a packet 0.5s later.
   Simulator::Schedule (Seconds (2.0), &TestInterBssConstantObssPdAlgo::ClearDropReasons, this);
   Simulator::Schedule (Seconds (2.0), &TestInterBssConstantObssPdAlgo::SendOnePacket, this, ap_device2, sta_device2, m_payloadSize2);
-  Simulator::Schedule (Seconds (2.0) + MicroSeconds (5), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, ap_device2, WifiPhyState::TX);
+  Simulator::Schedule (Seconds (2.0) + MicroSeconds (10), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, ap_device2, WifiPhyState::TX);
   // All other PHYs should have stay idle until 4us (preamble detection time).
-  Simulator::Schedule (Seconds (2.0) + MicroSeconds (6), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, sta_device1, WifiPhyState::IDLE);
-  Simulator::Schedule (Seconds (2.0) + MicroSeconds (6), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, sta_device2, WifiPhyState::IDLE);
-  Simulator::Schedule (Seconds (2.0) + MicroSeconds (6), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, ap_device1, WifiPhyState::IDLE);
+  Simulator::Schedule (Seconds (2.0) + MicroSeconds (13), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, sta_device1, WifiPhyState::IDLE);
+  Simulator::Schedule (Seconds (2.0) + MicroSeconds (13), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, sta_device2, WifiPhyState::IDLE);
+  Simulator::Schedule (Seconds (2.0) + MicroSeconds (13), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, ap_device1, WifiPhyState::IDLE);
   // All PHYs should be receiving the PHY header (i.e. PHY state is CCA_BUSY) if preamble has been detected (always the case in this test).
-  Simulator::Schedule (Seconds (2.0) + MicroSeconds (10), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, sta_device1, WifiPhyState::CCA_BUSY);
-  Simulator::Schedule (Seconds (2.0) + MicroSeconds (10), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, sta_device2, WifiPhyState::CCA_BUSY);
-  Simulator::Schedule (Seconds (2.0) + MicroSeconds (10), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, ap_device1, WifiPhyState::CCA_BUSY);
+  Simulator::Schedule (Seconds (2.0) + MicroSeconds (14), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, sta_device1, WifiPhyState::CCA_BUSY);
+  Simulator::Schedule (Seconds (2.0) + MicroSeconds (14), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, sta_device2, WifiPhyState::CCA_BUSY);
+  Simulator::Schedule (Seconds (2.0) + MicroSeconds (14), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, ap_device1, WifiPhyState::CCA_BUSY);
   // PHYs of AP1 and STA1 should be idle after HE-SIG-A if they were reset by OBSS_PD SR, otherwise they should be CCA_busy until beginning of payload.
-  Simulator::Schedule (Seconds (2.0) + MicroSeconds (35), &TestInterBssConstantObssPdAlgo::CheckPhyDropReasons, this, sta_device1, dropReasons);
-  Simulator::Schedule (Seconds (2.0) + MicroSeconds (35), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, sta_device1, expectPhyReset ? WifiPhyState::IDLE : WifiPhyState::CCA_BUSY);
-  Simulator::Schedule (Seconds (2.0) + MicroSeconds (35), &TestInterBssConstantObssPdAlgo::CheckPhyDropReasons, this, ap_device1, dropReasons);
-  Simulator::Schedule (Seconds (2.0) + MicroSeconds (35), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, ap_device1, expectPhyReset ? WifiPhyState::IDLE : WifiPhyState::CCA_BUSY);
+  Simulator::Schedule (Seconds (2.0) + MicroSeconds (43), &TestInterBssConstantObssPdAlgo::CheckPhyDropReasons, this, sta_device1, dropReasons);
+  Simulator::Schedule (Seconds (2.0) + MicroSeconds (43), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, sta_device1, expectPhyReset ? WifiPhyState::IDLE : WifiPhyState::CCA_BUSY);
+  Simulator::Schedule (Seconds (2.0) + MicroSeconds (43), &TestInterBssConstantObssPdAlgo::CheckPhyDropReasons, this, ap_device1, dropReasons);
+  Simulator::Schedule (Seconds (2.0) + MicroSeconds (43), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, ap_device1, expectPhyReset ? WifiPhyState::IDLE : WifiPhyState::CCA_BUSY);
   // PHYs of AP1 and STA1 should be idle if they were reset by OBSS_PD SR, otherwise they should be CCA_busy/Rx (since filtered/not filtered, resp.).
-  Simulator::Schedule (Seconds (2.0) + MicroSeconds (50), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, sta_device1, expectPhyReset ? WifiPhyState::IDLE : stateDuringPayloadNeighboringBss);
-  Simulator::Schedule (Seconds (2.0) + MicroSeconds (50), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, ap_device1, expectPhyReset ? WifiPhyState::IDLE : stateDuringPayloadNeighboringBss);
+  Simulator::Schedule (Seconds (2.0) + MicroSeconds (54), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, sta_device1, expectPhyReset ? WifiPhyState::IDLE : stateDuringPayloadNeighboringBss);
+  Simulator::Schedule (Seconds (2.0) + MicroSeconds (54), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, ap_device1, expectPhyReset ? WifiPhyState::IDLE : stateDuringPayloadNeighboringBss);
   // STA2 should be receiving
-  Simulator::Schedule (Seconds (2.0) + MicroSeconds (50), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, sta_device2, WifiPhyState::RX);
+  Simulator::Schedule (Seconds (2.0) + MicroSeconds (54), &TestInterBssConstantObssPdAlgo::CheckPhyState, this, sta_device2, WifiPhyState::RX);
 
   // We test whether two networks can transmit simultaneously, and whether transmit power restrictions are applied.
 
@@ -544,8 +544,8 @@
 TestInterBssConstantObssPdAlgo::RunOne (void)
 {
   RngSeedManager::SetSeed (1);
-  RngSeedManager::SetRun (1);
-  int64_t streamNumber = 2;
+  RngSeedManager::SetRun (3);
+  int64_t streamNumber = 50;
   
   Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/BE_MaxAmpduSize", UintegerValue (0));
 
@@ -569,10 +569,10 @@
   phy.SetChannel (channel);
   phy.Set ("TxPowerStart", DoubleValue (m_txPowerDbm));
   phy.Set ("TxPowerEnd", DoubleValue (m_txPowerDbm));
-  phy.Set ("ChannelWidth", UintegerValue (20));
+  phy.Set ("ChannelSettings", StringValue ("{36, 20, BAND_5GHZ, 0}"));
 
   WifiHelper wifi;
-  wifi.SetStandard (WIFI_STANDARD_80211ax_5GHZ);
+  wifi.SetStandard (WIFI_STANDARD_80211ax);
   wifi.SetRemoteStationManager ("ns3::ConstantRateWifiManager",
                                 "DataMode", StringValue ("HeMcs5"),
                                 "ControlMode", StringValue ("HeMcs0"));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/test/power-rate-adaptation-test.cc ns-3.36/src/wifi/test/power-rate-adaptation-test.cc
--- ns-3.35/src/wifi/test/power-rate-adaptation-test.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/test/power-rate-adaptation-test.cc	2022-04-30 18:23:58.218735200 -0700
@@ -102,7 +102,7 @@
   phy->SetChannel (channel);
   phy->SetDevice (dev);
   phy->SetMobility (mobility);
-  phy->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211a, WIFI_PHY_BAND_5GHZ);
+  phy->ConfigureStandard (WIFI_STANDARD_80211a);
 
   /*
    * Configure power control parameters.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/test/spectrum-wifi-phy-test.cc ns-3.36/src/wifi/test/spectrum-wifi-phy-test.cc
--- ns-3.35/src/wifi/test/spectrum-wifi-phy-test.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/test/spectrum-wifi-phy-test.cc	2022-04-30 18:23:58.218735200 -0700
@@ -175,11 +175,10 @@
 SpectrumWifiPhyBasicTest::DoSetup (void)
 {
   m_phy = CreateObject<SpectrumWifiPhy> ();
-  m_phy->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211n, WIFI_PHY_BAND_5GHZ);
+  m_phy->SetOperatingChannel (WifiPhy::ChannelTuple {CHANNEL_NUMBER, 0, WIFI_PHY_BAND_5GHZ, 0});
+  m_phy->ConfigureStandard (WIFI_STANDARD_80211n);
   Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel> ();
   m_phy->SetErrorRateModel (error);
-  m_phy->SetChannelNumber (CHANNEL_NUMBER);
-  m_phy->SetFrequency (FREQUENCY);
   m_phy->SetReceiveOkCallback (MakeCallback (&SpectrumWifiPhyBasicTest::SpectrumWifiPhyRxSuccess, this));
   m_phy->SetReceiveErrorCallback (MakeCallback (&SpectrumWifiPhyBasicTest::SpectrumWifiPhyRxFailure, this));
 }
@@ -471,7 +470,7 @@
   Ptr<WifiNetDevice> txDev = CreateObject<WifiNetDevice> ();
   m_txPhy = CreateObject<ExtSpectrumWifiPhy> ();
   m_txPhy->CreateWifiSpectrumPhyInterface (txDev);
-  m_txPhy->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  m_txPhy->ConfigureStandard (WIFI_STANDARD_80211ax);
   Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel> ();
   m_txPhy->SetErrorRateModel (error);
   m_txPhy->SetDevice (txDev);
@@ -486,7 +485,7 @@
   Ptr<WifiNetDevice> rxDev = CreateObject<WifiNetDevice> ();
   m_rxPhy = CreateObject<ExtSpectrumWifiPhy> ();
   m_rxPhy->CreateWifiSpectrumPhyInterface (rxDev);
-  m_rxPhy->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  m_rxPhy->ConfigureStandard (WIFI_STANDARD_80211ax);
   m_rxPhy->SetErrorRateModel (error);
   m_rxPhy->SetChannel (spectrumChannel);
   Ptr<ConstantPositionMobilityModel> sta1Mobility = CreateObject<ConstantPositionMobilityModel> ();
@@ -526,7 +525,11 @@
       txFrequency = 5250;
       break;
     }
-  m_txPhy->SetFrequency (txFrequency);
+  auto txChannelNum = std::get<0> (*WifiPhyOperatingChannel::FindFirst (0, txFrequency, m_txChannelWidth,
+                                                                        WIFI_STANDARD_80211ax,
+                                                                        WIFI_PHY_BAND_5GHZ));
+  m_txPhy->SetOperatingChannel (WifiPhy::ChannelTuple {txChannelNum, m_txChannelWidth,
+                                                       (int)(WIFI_PHY_BAND_5GHZ), 0});
 
   uint16_t rxFrequency;
   switch (m_rxChannelWidth)
@@ -545,7 +548,11 @@
       rxFrequency = 5250;
       break;
     }
-  m_rxPhy->SetFrequency (rxFrequency);
+  auto rxChannelNum = std::get<0> (*WifiPhyOperatingChannel::FindFirst (0, rxFrequency, m_rxChannelWidth,
+                                                                        WIFI_STANDARD_80211ax,
+                                                                        WIFI_PHY_BAND_5GHZ));
+  m_rxPhy->SetOperatingChannel (WifiPhy::ChannelTuple {rxChannelNum, m_rxChannelWidth,
+                                                       (int)(WIFI_PHY_BAND_5GHZ), 0});
 
   m_ruBands.clear ();
   for (uint16_t bw = 160; bw >= 20; bw = bw / 2)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/test/wifi-aggregation-test.cc ns-3.36/src/wifi/test/wifi-aggregation-test.cc
--- ns-3.35/src/wifi/test/wifi-aggregation-test.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/test/wifi-aggregation-test.cc	2022-04-30 18:23:58.218735200 -0700
@@ -103,7 +103,7 @@
    */
   m_phy = CreateObject<YansWifiPhy> ();
   m_phy->SetDevice (m_device);
-  m_phy->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211n, WIFI_PHY_BAND_5GHZ);
+  m_phy->ConfigureStandard (WIFI_STANDARD_80211n);
   m_device->SetPhy (m_phy);
 
   /*
@@ -119,11 +119,11 @@
   /*
    * Create and configure mac layer.
    */
-  m_mac = CreateObject<StaWifiMac> ();
+  m_mac = CreateObjectWithAttributes<StaWifiMac> ("QosSupported", BooleanValue (true));
   m_mac->SetDevice (m_device);
   m_mac->SetWifiRemoteStationManager (m_manager);
   m_mac->SetAddress (Mac48Address ("00:00:00:00:00:01"));
-  m_mac->ConfigureStandard (WIFI_STANDARD_80211n_5GHZ);
+  m_mac->ConfigureStandard (WIFI_STANDARD_80211n);
   Ptr<FrameExchangeManager> fem = m_mac->GetFrameExchangeManager ();
   Ptr<WifiProtectionManager> protectionManager = CreateObject<WifiDefaultProtectionManager> ();
   protectionManager->SetWifiMac (m_mac);
@@ -133,6 +133,7 @@
   fem->SetAckManager (ackManager);
   m_mac->SetWifiPhy (m_phy);
   m_device->SetMac (m_mac);
+  m_mac->SetState (StaWifiMac::ASSOCIATED);
 
   /*
    * Configure MPDU aggregation.
@@ -175,7 +176,7 @@
   respHdr.SetAmsduSupport (reqHdr.IsAmsduSupported ());
   respHdr.SetImmediateBlockAck ();
   respHdr.SetTid (reqHdr.GetTid ());
-  respHdr.SetBufferSize (63);
+  respHdr.SetBufferSize (64);
   respHdr.SetTimeout (reqHdr.GetTimeout ());
   m_mac->GetBEQueue ()->GetBaManager ()->UpdateAgreement (&respHdr, hdr.GetAddr1 (), 0);
 
@@ -192,11 +193,9 @@
   Ptr<const WifiMacQueueItem> peeked = m_mac->GetBEQueue ()->PeekNextMpdu ();
   WifiTxParameters txParams;
   txParams.m_txVector = m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (peeked->GetHeader ());
-  WifiMacQueueItem::ConstIterator queueIt;
-  Ptr<WifiMacQueueItem> item = m_mac->GetBEQueue ()->GetNextMpdu (peeked, txParams, Time::Min (),
-                                                                  true, queueIt);
+  Ptr<WifiMacQueueItem> item = m_mac->GetBEQueue ()->GetNextMpdu (peeked, txParams, Time::Min (), true);
 
-  auto mpduList = mpduAggregator->GetNextAmpdu (item, txParams, Time::Min (), queueIt);
+  auto mpduList = mpduAggregator->GetNextAmpdu (item, txParams, Time::Min ());
 
   NS_TEST_EXPECT_MSG_EQ (mpduList.empty (), true, "a single packet should not result in an A-MPDU");
 
@@ -225,8 +224,8 @@
   m_mac->GetBEQueue ()->GetWifiMacQueue ()->Enqueue (Create<WifiMacQueueItem> (pkt1, hdr1));
   m_mac->GetBEQueue ()->GetWifiMacQueue ()->Enqueue (Create<WifiMacQueueItem> (pkt2, hdr2));
 
-  item = m_mac->GetBEQueue ()->GetNextMpdu (peeked, txParams, Time::Min (), true, queueIt);
-  mpduList = mpduAggregator->GetNextAmpdu (item, txParams, Time::Min (), queueIt);
+  item = m_mac->GetBEQueue ()->GetNextMpdu (peeked, txParams, Time::Min (), true);
+  mpduList = mpduAggregator->GetNextAmpdu (item, txParams, Time::Min ());
 
   NS_TEST_EXPECT_MSG_EQ (mpduList.empty (), false, "MPDU aggregation failed");
 
@@ -276,10 +275,9 @@
   peeked = m_mac->GetBEQueue ()->PeekNextMpdu ();
   txParams.Clear ();
   txParams.m_txVector = m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (peeked->GetHeader ());
-  queueIt = WifiMacQueue::EMPTY;  // reset queueIt
-  item = m_mac->GetBEQueue ()->GetNextMpdu (peeked, txParams, Time::Min (), true, queueIt);
+  item = m_mac->GetBEQueue ()->GetNextMpdu (peeked, txParams, Time::Min (), true);
 
-  mpduList = mpduAggregator->GetNextAmpdu (item, txParams, Time::Min (), queueIt);
+  mpduList = mpduAggregator->GetNextAmpdu (item, txParams, Time::Min ());
 
   NS_TEST_EXPECT_MSG_EQ (mpduList.empty (), true, "a single packet for this destination should not result in an A-MPDU");
   // dequeue the MPDU
@@ -288,10 +286,9 @@
   peeked = m_mac->GetBEQueue ()->PeekNextMpdu ();
   txParams.Clear ();
   txParams.m_txVector = m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (peeked->GetHeader ());
-  queueIt = WifiMacQueue::EMPTY;  // reset queueIt
-  item = m_mac->GetBEQueue ()->GetNextMpdu (peeked, txParams, Time::Min (), true, queueIt);
+  item = m_mac->GetBEQueue ()->GetNextMpdu (peeked, txParams, Time::Min (), true);
 
-  mpduList = mpduAggregator->GetNextAmpdu (item, txParams, Time::Min (), queueIt);
+  mpduList = mpduAggregator->GetNextAmpdu (item, txParams, Time::Min ());
 
   NS_TEST_EXPECT_MSG_EQ (mpduList.empty (), true, "no MPDU aggregation should be performed if there is no agreement");
 
@@ -346,6 +343,7 @@
    * Create device and attach HT configuration.
    */
   m_device = CreateObject<WifiNetDevice> ();
+  m_device->SetStandard (WIFI_STANDARD_80211n);
   Ptr<HtConfiguration> htConfiguration = CreateObject<HtConfiguration> ();
   m_device->SetHtConfiguration (htConfiguration);
 
@@ -354,7 +352,7 @@
    */
   m_phy = CreateObject<YansWifiPhy> ();
   m_phy->SetDevice (m_device);
-  m_phy->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211n, WIFI_PHY_BAND_5GHZ);
+  m_phy->ConfigureStandard (WIFI_STANDARD_80211n);
   m_device->SetPhy (m_phy);
 
   /*
@@ -370,11 +368,11 @@
   /*
    * Create and configure mac layer.
    */
-  m_mac = CreateObject<StaWifiMac> ();
+  m_mac = CreateObjectWithAttributes<StaWifiMac> ("QosSupported", BooleanValue (true));
   m_mac->SetDevice (m_device);
   m_mac->SetWifiRemoteStationManager (m_manager);
   m_mac->SetAddress (Mac48Address ("00:00:00:00:00:01"));
-  m_mac->ConfigureStandard (WIFI_STANDARD_80211n_5GHZ);
+  m_mac->ConfigureStandard (WIFI_STANDARD_80211n);
   Ptr<FrameExchangeManager> fem = m_mac->GetFrameExchangeManager ();
   Ptr<WifiProtectionManager> protectionManager = CreateObject<WifiDefaultProtectionManager> ();
   protectionManager->SetWifiMac (m_mac);
@@ -384,6 +382,7 @@
   fem->SetAckManager (ackManager);
   m_mac->SetWifiPhy (m_phy);
   m_device->SetMac (m_mac);
+  m_mac->SetState (StaWifiMac::ASSOCIATED);
 
   /*
    * Configure aggregation.
@@ -424,8 +423,7 @@
   WifiTxParameters txParams;
   txParams.m_txVector = m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (peeked->GetHeader ());
   htFem->TryAddMpdu (peeked, txParams, Time::Min ());
-  WifiMacQueueItem::ConstIterator queueIt;
-  Ptr<WifiMacQueueItem> item = msduAggregator->GetNextAmsdu (peeked, txParams, Time::Min (), queueIt);
+  Ptr<WifiMacQueueItem> item = msduAggregator->GetNextAmsdu (peeked, txParams, Time::Min ());
 
   bool result = (item != 0);
   NS_TEST_EXPECT_MSG_EQ (result, true, "aggregation failed");
@@ -447,11 +445,11 @@
   txParams.Clear ();
   txParams.m_txVector = m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (peeked->GetHeader ());
   htFem->TryAddMpdu (peeked, txParams, Time::Min ());
-  item = msduAggregator->GetNextAmsdu (peeked, txParams, Time::Min (), queueIt);
+  item = msduAggregator->GetNextAmsdu (peeked, txParams, Time::Min ());
 
   NS_TEST_EXPECT_MSG_EQ ((item == 0), true, "A-MSDU aggregation did not fail");
 
-  htFem->DequeueMpdu (*peeked->GetQueueIterator ());
+  htFem->DequeueMpdu (peeked);
 
   NS_TEST_EXPECT_MSG_EQ (m_mac->GetBEQueue ()->GetWifiMacQueue ()->GetNPackets (), 0, "queue should be empty");
 
@@ -479,7 +477,7 @@
   respHdr.SetAmsduSupport (reqHdr.IsAmsduSupported ());
   respHdr.SetImmediateBlockAck ();
   respHdr.SetTid (reqHdr.GetTid ());
-  respHdr.SetBufferSize (63);
+  respHdr.SetBufferSize (64);
   respHdr.SetTimeout (reqHdr.GetTimeout ());
   m_mac->GetVIQueue ()->GetBaManager ()->UpdateAgreement (&respHdr, hdr.GetAddr1 (), 0);
 
@@ -502,12 +500,11 @@
 
   // Compute the first MPDU to be aggregated in an A-MPDU. It must contain an A-MSDU
   // aggregating two MSDUs
-  queueIt = WifiMacQueue::EMPTY;  // reset queueIt
-  item = m_mac->GetVIQueue ()->GetNextMpdu (peeked, txParams, txopLimit, true, queueIt);
+  item = m_mac->GetVIQueue ()->GetNextMpdu (peeked, txParams, txopLimit, true);
 
   NS_TEST_EXPECT_MSG_EQ (std::distance (item->begin (), item->end ()), 2, "There must be 2 MSDUs in the A-MSDU");
 
-  auto mpduList = mpduAggregator->GetNextAmpdu (item, txParams, txopLimit, queueIt);
+  auto mpduList = mpduAggregator->GetNextAmpdu (item, txParams, txopLimit);
 
   // The maximum number of bytes that can be transmitted in a TXOP is (approximately, as we
   // do not consider that the preamble is transmitted at a different rate):
@@ -526,7 +523,7 @@
 
   Ptr<WifiPsdu> psdu = Create<WifiPsdu> (mpduList);
   htFem->DequeuePsdu (psdu);
-  
+
   NS_TEST_EXPECT_MSG_EQ (m_mac->GetVIQueue ()->GetWifiMacQueue ()->GetNPackets (), 5,
                          "Unexpected number of MSDUs left in the EDCA queue");
 
@@ -589,7 +586,7 @@
    */
   m_phy = CreateObject<YansWifiPhy> ();
   m_phy->SetDevice (m_device);
-  m_phy->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  m_phy->ConfigureStandard (WIFI_STANDARD_80211ax);
   m_device->SetPhy (m_phy);
 
   /*
@@ -605,11 +602,11 @@
   /*
    * Create and configure mac layer.
    */
-  m_mac = CreateObject<StaWifiMac> ();
+  m_mac = CreateObjectWithAttributes<StaWifiMac> ("QosSupported", BooleanValue (true));
   m_mac->SetDevice (m_device);
   m_mac->SetWifiRemoteStationManager (m_manager);
   m_mac->SetAddress (Mac48Address ("00:00:00:00:00:01"));
-  m_mac->ConfigureStandard (WIFI_STANDARD_80211ax_5GHZ);
+  m_mac->ConfigureStandard (WIFI_STANDARD_80211ax);
   Ptr<FrameExchangeManager> fem = m_mac->GetFrameExchangeManager ();
   Ptr<WifiProtectionManager> protectionManager = CreateObject<WifiDefaultProtectionManager> ();
   protectionManager->SetWifiMac (m_mac);
@@ -619,6 +616,7 @@
   fem->SetAckManager (ackManager);
   m_mac->SetWifiPhy (m_phy);
   m_device->SetMac (m_mac);
+  m_mac->SetState (StaWifiMac::ASSOCIATED);
 
   /*
    * Configure aggregation.
@@ -658,7 +656,7 @@
   respHdr.SetAmsduSupport (reqHdr.IsAmsduSupported ());
   respHdr.SetImmediateBlockAck ();
   respHdr.SetTid (reqHdr.GetTid ());
-  respHdr.SetBufferSize (bufferSize - 1);
+  respHdr.SetBufferSize (bufferSize);
   respHdr.SetTimeout (reqHdr.GetTimeout ());
   m_mac->GetBEQueue ()->GetBaManager ()->UpdateAgreement (&respHdr, hdr.GetAddr1 (), 0);
 
@@ -684,11 +682,9 @@
   Ptr<const WifiMacQueueItem> peeked = m_mac->GetBEQueue ()->PeekNextMpdu ();
   WifiTxParameters txParams;
   txParams.m_txVector = m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (peeked->GetHeader ());
-  WifiMacQueueItem::ConstIterator queueIt;
-  Ptr<WifiMacQueueItem> item = m_mac->GetBEQueue ()->GetNextMpdu (peeked, txParams, Time::Min (),
-                                                                  true, queueIt);
-  
-  auto mpduList = mpduAggregator->GetNextAmpdu (item, txParams, Time::Min (), queueIt);
+  Ptr<WifiMacQueueItem> item = m_mac->GetBEQueue ()->GetNextMpdu (peeked, txParams, Time::Min (), true);
+
+  auto mpduList = mpduAggregator->GetNextAmpdu (item, txParams, Time::Min ());
   Ptr<WifiPsdu> psdu = Create<WifiPsdu> (mpduList);
   htFem->DequeuePsdu (psdu);
 
@@ -827,7 +823,7 @@
   phy.SetChannel (channel.Create ());
 
   WifiHelper wifi;
-  wifi.SetStandard (WIFI_STANDARD_80211n_5GHZ);
+  wifi.SetStandard (WIFI_STANDARD_80211n);
   wifi.SetRemoteStationManager ("ns3::IdealWifiManager");
 
   WifiMacHelper mac;
